itpp::Sparse_Vec< T > Class Template Reference

Templated sparse vector class. More...

`#include <itpp/base/svec.h>`

## Public Member Functions

| Sparse_Vec ()
| Default constructor.
| Sparse_Vec (int sz, int data_init=200)
| Initiate an empty sparse vector. More...
| Sparse_Vec (const Sparse_Vec< T > &v)
| Initiate a new sparse vector. More...
| Sparse_Vec (const Vec< T > &v)
| Initiate a new sparse vector from a dense vector. More...
| Sparse_Vec (const Vec< T > &v, T epsilon)
| Initiate a new sparse vector from a dense vector. Elements of `v` larger than `epsilon` are copied into the new sparse vector. More...
| ~Sparse_Vec ()
| Destructor.
void | set_size (int sz, int data_init=-1)
| Set the size `sz` of the sparse vector. Default value `data_init=-1` `=>` allocated size for the data is not changed. More...
int | size () const
| Returns the size of the sparse vector.
int | nnz ()
| Number of non-zero elements in the sparse vector.
double | density ()
| Returns the density of the sparse vector: (number of non-zero elements)/(size of the vector)
void | set_small_element (const T &epsilon)
| Set that all elements smaller than epsilon should be set to zero.
void | remove_small_elements ()
void | resize_data (int new_size)
| Set the maximum number of non-zero elements to `new_size`. More...
void | compact ()
| Set the maximum number of non-zero elements equal to the actual number of non-zero elements.
void | full (Vec< T > &v) const
| Returns a full, dense vector in `v`.
Vec< T > | full () const
| Returns a full, dense vector.
T | operator() (int i) const
| Returns the element with index `i`.
void | set (int i, T v)
| Set element `i` equal to `v`.
void | set (const ivec &index_vec, const Vec< T > &v)
| Set the elements of the sparse vector with indices `index_vec` to the values in `v`.
void | set_new (int i, T v)
| Set a new element with index `i` equal to `v`.
void | set_new (const ivec &index_vec, const Vec< T > &v)
| Set new elements with indices `index_vec` equal to the values in `v` (no check whether the same index is used several times)
void | add_elem (const int i, const T v)
| Add element `i` with `v`.
void | add (const ivec &index_vec, const Vec< T > &v)
| Add `v` to the elements specified by `index_vec` with `v`.
void | zeros ()
| Set the sparse vector to the all zero vector (removes all non-zero elements)
void | zero_elem (const int i)
| Set the i-th element to zero (i.e. clear that element if it contains a non-zero value)
void | clear ()
| Clear all non-zero elements of the sparse vector.
void | clear_elem (const int i)
| Clear the i-th element (if it contains a non-zero value)
void | get_nz_data (int p, T &data_out)
| Extract the reference to the p-th non-zero data element.
T | get_nz_data (int p)
| Returns the p-th non-zero data element.
int | get_nz_index (int p)
| Returns the vector index of the p-th non-zero element.
void | get_nz (int p, int &idx, T &dat)
| Returns the p-th non-zero value in `dat` and the corresponding vector index in `idx`.
ivec | get_nz_indices ()
| Return the indices of non-zero values.
Sparse_Vec< T > | get_subvector (int i1, int i2) const
| Return sparse subvector from index `i1` to index `i2`.
T | sqr () const
| Returns the sum of all values squared.
void | operator= (const Sparse_Vec< T > &v)
| Assign sparse vector the value and length of the sparse vector `v`.
void | operator= (const Vec< T > &v)
| Assign sparse vector the value and length of the dense vector `v`.
Sparse_Vec< T > | operator- () const
| Returns the sign inverse of all elements in the sparse vector.
bool | operator== (const Sparse_Vec< T > &v)
| Compare two sparse vectors. False if wrong sizes or different values.
void | operator+= (const Sparse_Vec< T > &v)
| Add sparse vector `v` to all non-zero elements of the sparse vector.
void | operator+= (const Vec< T > &v)
| Add vector `v` to all non-zero elements of the sparse vector.
void | operator-= (const Sparse_Vec< T > &v)
| Subtract sparse vector `v` from all non-zero elements of the sparse vector.
void | operator-= (const Vec< T > &v)
| Subtract vector `v` from all non-zero elements of the sparse vector.
void | operator*= (const T &v)
| Multiply the scalar `v` to all non-zero elements of the sparse vector.
void | operator/= (const T &v)
| Divide all non-zero elements of the sparse vector with the scalar `v`.

## Friends

Sparse_Vec< T > | operator+ (const Sparse_Vec< T > &v1, const Sparse_Vec< T > &v2)
| Addition v1+v2 where v1 and v2 are sparse vector.
T | operator* (const Sparse_Vec< T > &v1, const Sparse_Vec< T > &v2)
| Scalar product v1*v2 where v1 and v2 are sparse vectors.
T | operator* (const Sparse_Vec< T > &v1, const Vec< T > &v2)
| Scalar product v1*v2 where v1 is a sparse vector and v2 is a dense vector.
T | operator* (const Vec< T > &v1, const Sparse_Vec< T > &v2)
| Scalar product v1*v2 where v1 is a dense vector and v2 is a sparse vector.
Sparse_Vec< T > | elem_mult (const Sparse_Vec< T > &v1, const Sparse_Vec< T > &v2)
| Element wise multiplication of two sparse vectors.
Vec< T > | elem_mult (const Sparse_Vec< T > &v1, const Vec< T > &v2)
| Element wise multiplication of a sparse vector and a dense vector.
Sparse_Vec< T > | elem_mult_s (const Sparse_Vec< T > &v1, const Vec< T > &v2)
| Element wise multiplication of a sparse vector and a dense vector returning a sparse vector.
Vec< T > | elem_mult (const Vec< T > &v1, const Sparse_Vec< T > &v2)
| Element wise multiplication of a a dense vector and a sparse vector.
Sparse_Vec< T > | elem_mult_s (const Vec< T > &v1, const Sparse_Vec< T > &v2)
| Element wise multiplication of a a dense vector and a sparse vector returning a sparse vector.

## Related Functions

(Note that these are not member functions.)
typedef Sparse_Vec< int > | sparse_ivec
| Type definition of an integer sparse vector.
typedef Sparse_Vec< double > | sparse_vec
| Type definition of a double sparse vector.
typedef Sparse_Vec < std::complex< double > > | sparse_cvec
| Type definition of a complex<double> sparse vector.

## Detailed Description

### template<class T>
class itpp::Sparse_Vec< T >

Templated sparse vector class.

Author
  Tony Ottosson and Tobias Ringstrom

A sparse vector is a vector where most elements are zero. The maximum number of none-zero elements is a parameter to the constructor. The elements are stored in random order, i.e. they are not sorted.

Definition at line 43 of file smat.h.

## Constructor & Destructor Documentation

template<class T >

itpp::Sparse_Vec< T >::Sparse_Vec | ( | int | sz,
|  | int | data_init = `200`
| ) |  |

Initiate an empty sparse vector.

Parameters

  sz | Size of the sparse vector (i.e. maximum index is (`sz` - 1))
  data_init | Maximum number of non-zero elements in the sparse vector (default value 200)

Definition at line 394 of file svec.h.

template<class T>

itpp::Sparse_Vec< T >::Sparse_Vec | ( | const Sparse_Vec< T > & | v | ) |

Initiate a new sparse vector.

Parameters

  v | The elements of `v` are copied into the new sparse vector

Definition at line 404 of file svec.h.

References itpp::eps.

template<class T>

itpp::Sparse_Vec< T >::Sparse_Vec | ( | const Vec< T > & | v | ) |

Initiate a new sparse vector from a dense vector.

Parameters

  v | The elements of `v` are copied into the new sparse vector

Definition at line 421 of file svec.h.

References itpp::min(), and itpp::Vec< Num_T >::size().

template<class T>

itpp::Sparse_Vec< T >::Sparse_Vec | ( | const Vec< T > & | v,
|  | T | epsilon
| ) |  |

Initiate a new sparse vector from a dense vector. Elements of `v` larger than `epsilon` are copied into the new sparse vector.

Note
  If the type T is complex<double>, then the elements of `v` larger than `abs(epsilon)` are copied into the new sparse vector.

Definition at line 442 of file svec.h.

References itpp::abs(), itpp::eps, itpp::min(), and itpp::Vec< Num_T >::size().

## Member Function Documentation

template<class T >

void itpp::Sparse_Vec< T >::set_size | ( | int | sz,
|  | int | data_init = `-1`
| ) |  |

Set the size `sz` of the sparse vector. Default value `data_init=-1` `=>` allocated size for the data is not changed.

Parameters

  sz | Size of the sparse vector (i.e. maximum index is (`sz` - 1))
  data_init | Maximum number of non-zero elements in the sparse vector (default value -1 `=>` allocated size for the data is not changed)

Definition at line 470 of file svec.h.

template<class T >

void itpp::Sparse_Vec< T >::remove_small_elements | ( |  | ) |

Removes all elements that are smaller than epsilon from the non-zero elements.

Note
  The small element epsilon can be set by the member function set_small_element. If no small value is set, the default value is always `epsilon=0`.

Definition at line 499 of file svec.h.

References itpp::abs(), and itpp::eps.

Referenced by itpp::Sparse_Vec< bin >::get_nz(), itpp::Sparse_Vec< bin >::get_nz_data(), itpp::Sparse_Vec< bin >::get_nz_index(), and itpp::Sparse_Vec< bin >::nnz().

template<class T >

void itpp::Sparse_Vec< T >::resize_data | ( | int | new_size | ) |

Set the maximum number of non-zero elements to `new_size`.

Parameters

  new_size | The new maximum number of non-zero elements.

Definition at line 524 of file svec.h.

References it_assert.

The documentation for this class was generated from the following files:

- itpp/base/smat.h
- itpp/base/svec.h

Generated on Thu Mar 20 2014 12:26:46 for IT++ by Doxygen 1.8.6